import sys

from mongo.get_conn import db_conn
import pandas as pd
import duckdb

class TableBuilder():
    def __init__(self) -> None:
        self.db = db_conn()

    def table_build(self, limit=10) -> pd.DataFrame:
        data = self.db.beer_db
        data = data.find({}).sort("date", -1)
        df_dict = {}
        df_dict["beer_run_id"]=[]
        df_dict["sg"] = []
        df_dict["date"] = []
        df_dict["final_reading"] = []

        for record in data:
            df_dict["beer_run_id"].append(record["beer_run_id"])
            df_dict["sg"].append(record["sg"])
            df_dict["date"].append(record["date"])
            df_dict["final_reading"].append(record["final_reading"])
        df = pd.DataFrame(data=df_dict)
        sql = f"""
            SELECT  x.beer_run_id as "Beer Run", 
                    max(sg)  as "Max",
                    min(sg)  as "Min"
            FROM df x
            JOIN
            (   SELECT DISTINCT beer_run_id 
                FROM df
                WHERE final_reading = 'True'
            ) y ON x.beer_run_id = y.beer_run_id
            GROUP BY x.beer_run_id
            ORDER BY x.beer_run_id desc
            LIMIT {limit}
        """
        df_sum = duckdb.sql(sql).df()
        sql = f"""
            SELECT  *, 
                    ROUND(((CAST (max AS INTEGER) - CAST(min AS INTEGER)) / 7.36) + 0.5, 2) AS "Alcohol Prediction"
            FROM df_sum
        """
        df_calc = duckdb.sql(sql).df()
        return df_calc
    

